SystemOrganization addCategory: #ConfigurationOfDemo!

Object subclass: #ConfigurationOfDemo
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfDemo'!

!ConfigurationOfDemo class methodsFor: 'development support' stamp: 'JPSA 8/27/2012 04:14'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfDemo class methodsFor: 'private' stamp: 'JPSA 8/27/2012 04:14'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfDemo class methodsFor: 'private' stamp: 'JPSA 8/27/2012 04:14'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfDemo class methodsFor: 'private' stamp: 'JPSA 8/27/2012 04:14'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfDemo class methodsFor: 'metacello tool support' stamp: 'JPSA 8/27/2012 04:14'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfDemo class methodsFor: 'loading' stamp: 'JPSA 8/27/2012 04:14'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfDemo class methodsFor: 'loading' stamp: 'JPSA 8/27/2012 04:14'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfDemo class methodsFor: 'loading' stamp: 'JPSA 8/27/2012 04:14'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfDemo class methodsFor: 'accessing' stamp: 'JPSA 8/27/2012 04:14'!
project

	^self new project! !

!ConfigurationOfDemo class methodsFor: 'development support' stamp: 'JPSA 8/27/2012 04:14'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfDemo methodsFor: 'baselines' stamp: 'JPSA 8/27/2012 04:14'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/VExample'.
		spec package: 'Demo'.
		spec group: 'default' with: #('Demo' ). ].
! !

!ConfigurationOfDemo methodsFor: 'symbolic versions' stamp: 'JPSA 8/27/2012 04:15'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.1'.
! !

!ConfigurationOfDemo methodsFor: 'accessing' stamp: 'JPSA 8/27/2012 04:14'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfDemo methodsFor: 'versions' stamp: 'JPSA 8/27/2012 04:15'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '1.0 : adding bar method'.
		spec author: 'JPSA'.
		spec timestamp: '8/27/2012 04:15'.
		spec package: 'Demo' with: 'Demo-JPSA.2'. ].
! !

!ConfigurationOfDemo methodsFor: 'versions' stamp: 'JPSA 8/27/2012 05:40'!
version11: spec
	<version: '1.1' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '1.0 : adding bar method
1.1 : removing bar method'.
		spec author: 'JPSA'.
		spec timestamp: '8/27/2012 05:40'.
		spec package: 'Demo' with: 'Demo-JPSA.3'. ].
! !
